/** 
 * Project Name:jumper-test 
 * File Name:TestEcgRecord.java 
 * Package Name:com.jumper.record 
 * Date:2017年3月13日下午2:48:41 
 * Copyright (c) 2017, yangsheng@angeldoctor All Rights Reserved. 
 * 
*/  
package com.jumper.record.ecg.example;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import org.apache.log4j.Logger;
import org.junit.Test;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jumper.record.ecg.entity.EcgRecordQueryReq;
import com.jumper.record.ecg.entity.EcgSingleRecordReq;
import com.jumper.record.utils.BaseVerify;
import com.jumper.record.utils.Const;
import com.jumper.record.utils.HttpClientTools;
/**
 * 心电查询测试用例
 * @author yangsheng@angeldoctor.net
 *
 */
public class TestEcgRecord {
	
	protected Logger logger = Logger.getLogger(this.getClass());  
	
	/**
	 * 根据ID获取心电数据
	 * @author yangsheng@angeldoctor
	 */
	@Test
	 public void getBusinessEcgRecordById(){
		 EcgSingleRecordReq req = new EcgSingleRecordReq();
		 req.setBusinessId(Const.businessId);
		 req.setId(136);
		 
		 BaseVerify verify = new BaseVerify();
		 String sign = verify.buildSign(req);
		 req.setSign(sign);
		 JSONObject json = (JSONObject)JSON.toJSON(req);
		 String str = HttpClientTools.builder().url(Const.url+"/openapi/ecg/getBusinessEcgRecordById").json(json).build().postJSON();
		 org.junit.Assert.assertNotNull(str);
		 logger.info(str);
	 }
	
	/**
	 * 批量获取心电数据
	 * @author yangsheng@angeldoctor 
	 * @throws ParseException
	 */
	@Test
	public void getBusinessEcgRecord() throws ParseException{
		EcgRecordQueryReq req  = new EcgRecordQueryReq();
		req.setPageNum(1);
		req.setPageSize(10);
		req.setBusinessId(Const.businessId);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// 可以方便地修改日期格式
		Date date = dateFormat.parse("2017-03-13 11:07:14");
		req.setCreateTime(date.getTime());
		BaseVerify verify = new BaseVerify();
		String sign = verify.buildSign(req);
		req.setSign(sign);
		 JSONObject json = (JSONObject)JSON.toJSON(req);
		String str = HttpClientTools.builder().url(Const.url+"/openapi/ecg/getBusinessEcgRecord").json(json).build().postJSON();
		org.junit.Assert.assertNotNull(str);
		logger.info(str);
	}
}
