/** 
 * Project Name:jumper-test 
 * File Name:TestHeartate.java 
 * Package Name:com.jumper.record 
 * Date:2017年3月10日下午4:44:20 
 * Copyright (c) 2017, yangsheng@angeldoctor All Rights Reserved. 
 * 
*/  
package com.jumper.record.heartrate.example;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import org.apache.log4j.Logger;
import org.junit.Test;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jumper.record.heartrate.entity.HeartrateRecordQueryReq;
import com.jumper.record.heartrate.entity.HeratraterSingleRecordReq;
import com.jumper.record.utils.BaseVerify;
import com.jumper.record.utils.Const;
import com.jumper.record.utils.HttpClientTools;
/**
 * 胎心
 * @author yangsheng yangsheng@angeldoctor.net
 *
 */
public class TestHeartate {
	
	protected Logger logger = Logger.getLogger(this.getClass()); 
	
	
	/**
	 * 批量获取胎心监测数据
	 * @author yangsheng@angeldoctor 
	 * @throws ParseException
	 */
	@Test 
	public void getBusinessFetalrateRecord() throws ParseException{
		HeartrateRecordQueryReq req = new HeartrateRecordQueryReq();
		req.setPageNum(1);
		req.setPageSize(10);
		req.setOpenUserId("11723");
		req.setBusinessId(Const.businessId);
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// 可以方便地修改日期格式
		Date date = dateFormat.parse("2017-03-14 11:07:14");
		req.setCreateTime(date.getTime());
		BaseVerify verify = new BaseVerify();
		String sign = verify.buildSign(req);
		req.setSign(sign);
		JSONObject json = (JSONObject)JSON.toJSON(req);
		String str = HttpClientTools.builder().url(Const.url+"/openapi/fetalrate/getBusinessFetalrateRecord").json(json).build().postJSON();
		org.junit.Assert.assertNotNull(str);
		logger.info(str);
	}
	
	/**
	 * 根据ID获取胎心监测数据
	 * @author yangsheng@angeldoctor 
	 * @throws ParseException
	 */
	@Test 
	public void getBusinessFetalrateRecordById() throws ParseException{
		HeratraterSingleRecordReq req = new HeratraterSingleRecordReq();
		req.setId(3430);
		req.setBusinessId(Const.businessId);
		BaseVerify verify = new BaseVerify();
		String sign = verify.buildSign(req);
		req.setSign(sign);
		JSONObject json = (JSONObject)JSON.toJSON(req);
		String str = HttpClientTools.builder().url(Const.url+"/openapi/fetalrate/getBusinessFetalrateRecordById").json(json).build().postJSON();
		org.junit.Assert.assertNotNull(str);
		logger.info(str);
	}
}
