/** 
 * Project Name:jumper-record-demo 
 * File Name:TestHeartrateReport.java 
 * Package Name:com.jumper.record.heartrate 
 * Date:2017年3月16日下午4:44:07 
 * Copyright (c) 2017, yangsheng@angeldoctor All Rights Reserved. 
 * 
*/  
package com.jumper.record.heartrate.example;
import org.apache.log4j.Logger;
import org.junit.Test;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jumper.record.heartrate.entity.HeratrateReportQueryReq;
import com.jumper.record.utils.BaseVerify;
import com.jumper.record.utils.Const;
import com.jumper.record.utils.HttpClientTools;
/**
 * 获取胎心监报告测试用例
 * @author yangsheng@angeldoctor.net
 *
 */
public class TestHeartrateReport {
	
	protected Logger logger = Logger.getLogger(this.getClass()); 
	
	/**
	 * 获取胎心监测报告
	 * @author yangsheng@angeldoctor
	 */
	@Test
	public void getHeartReport(){
		HeratrateReportQueryReq req = new HeratrateReportQueryReq();
		req.setId(1112);
		req.setBusinessId(Const.businessId);
		BaseVerify verify = new BaseVerify();
		String sign = verify.buildSign(req);
		req.setSign(sign);
		JSONObject json = (JSONObject)JSON.toJSON(req);
		String str = HttpClientTools.builder().url(Const.url+"/openapi/fetalrate/getBusinessFetalraetReprot").json(json).build().postJSON();
		org.junit.Assert.assertNotNull(str);
		logger.info(str);
	}
	
}
