/** 
 * Project Name:jumper-record-provider 
 * File Name:BaseVerify.java 
 * Package Name:com.jumper.record.verify 
 * Date:2017年3月13日下午1:52:43 
 * Copyright (c) 2017, yangsheng@angeldoctor All Rights Reserved. 
 * 
*/  
package com.jumper.record.utils;
import java.util.TreeMap;
import java.util.Map.Entry;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jumper.record.utils.MD5EncryptUtils;

public class BaseVerify implements java.io.Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 7075806185441780334L;
	
	protected Logger logger = Logger.getLogger(this.getClass());
	
	public  <T> String buildSign(T t){
		try {
			JSONObject reqJSON = (JSONObject)JSON.toJSON(t);
			reqJSON.remove("sign");
			//按key值进行排序,值为空不进行加密
			TreeMap<String,Object>  treeMap = new TreeMap<String,Object>();
			for(Entry<String,Object> entry : reqJSON.entrySet()){
				if(entry.getValue() !=null && StringUtils.isNotBlank(entry.getValue().toString())){
					treeMap.put(entry.getKey(), entry.getValue());
				}
			}
			StringBuilder builder = new StringBuilder();
			for(Entry<String,Object> entry : treeMap.entrySet()){
				builder.append(entry.getKey()).append("=").append(entry.getValue()).append("&");
			}
			//加密规则
			String sortResult = builder.delete(builder.length()-1, builder.length()).toString();
			String beforSign = Const.businessId+sortResult+Const.appId;
			logger.info("beforSign::"+beforSign);
			String sign = MD5EncryptUtils.getMd5Value(beforSign);
			logger.info("sign::"+sign);
			return sign;
		} catch (Exception e) {
			logger.error("BaseVerify.buildSign.error", e);
		}
		return "";
	} 
}
