/**
 * Canvas胎心图工具类
 * @auther rent
 * @date 2015-10-30
 **/
var ChartData = [];
var curNstData = "";

var Chart = function(){
	/** 浏览器是否支持canvas **/
	var isCanvas = true;
	/** 选择器正则 **/
	var idExpr = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/;
	var classExpr = /^(?:\s*(<[\w\W]+>)[^>]*|.([\w-]*))$/;
	
	/** Y轴每一格之间的距离 **/
	var vertical_size = 20;
	/** X轴每一格之间的距离 **/
	var horizontal_size = 40;
	/** 垂直多少个cell **/
	var required_vertical = 21;
	/** 水平多少个cell **/
	var required_horizontal = 60;
	/** 左侧Y轴坐标宽度 **/
	var label_weight = 50;
	/** 底部X轴坐标高度 **/
	var label_height = 50;
	/** canvas宽度 **/
	var canvas_width = 2400;
	/** canvas高度 **/
	var canvas_height = 420;
	/** 宫缩垂直多少个cell **/
	var uterus_vertical = 11;
	/** 宫缩图的高度 **/
	var uterus_height = 200;


	/** 拖动点计算 **/
	var offsetX = 0;
	var offsetY = 0;
	var default_start = 487;
	var default_end = 1687;
	var start_point = 487;
	var end_point = 1687;
	var offset_can = 0;

    /** 选取以后结果 **/
    var result_start = 0;
    var result_end = 2400;

	/** 颜色值数组定义 **/
	var colorSelect = {
		"line" : "rgb(241,137,168)",//红色线条颜色
		"safe" : "rgba(67,205,128,0.3)",//绿色正常背景填充颜色，0.3的透明度
		"black" : "rgb(0,0,0)",
		"grey" : "rgba(153,153,153,0.5)"
	};

	return {
		/** DOM查询canvas对象 **/
		get : function(id){
			return document.getElementById(id);
		},
		/** 获取胎心图的宽度 **/
		getCanvasWidth : function(){
			return canvas_width;
		},
		/** 获取胎心图的高度 **/
		getCanvasHeight : function(){
			return canvas_height;
		},
		/** 获取左侧Y轴坐标宽度 **/
		getLabelWeight : function(){
			return label_weight;
		},
		/** 获取底部X轴坐标高度 **/
		getLabelHeight : function(){
			return label_height;
		},
		setOffsetX : function(element, value){
			$("."+element).children(".offsetX").val(value);
		},
		getOffsetX : function(element){
			return $("."+element).children(".offsetX").val();
		},
		/** 获取宫缩图的高度 **/
		getUterusHeight : function(){
			return uterus_height;
		},
		/** 是否是整数 **/
		isInteger : function(object){
 			return typeof object === 'number' && object % 1 === 0;
		},
		getDataByElement : function(element){
			for(var i = 0;i < ChartData.length; i++){
				var item = ChartData[i];
				for(var key in item){
					if(key == element){
						return item[key];
					}
				}
			}
		},
		/** 总入口，准备数据，调用插件 **/
		init : function(config){
			/** 解析数据 **/
			var element = config.element;
			var data = "{"+element+":{\"fhr_data\":["+config.fhr+"], \"ua_data\":["+config.ua+"], \"fmp_data\":["+config.fmp+"]}}";
			ChartData.push(eval("("+data+")"));
			curNstData = "";
			curNstData = config.fhr+"-"+config.ua+"-"+config.fmp;
			/** 判断是否支持canvas,不支持则调用Flex **/
			var canvas = document.createElement("canvas");
	        if(!canvas.getContext || !canvas.getContext('2d')){
	            console.log("浏览器不支持Canvas！");
	            isCanvas = false;

	            var swfDiv = $("#"+element)[0];
	            swfDiv.style.width = "1280px";
	            swfDiv.style.height = "370px";

	            //var swfRoot = element.replace("#", "");
	            swfobject.embedSWF("nst.swf", element, "1280", "370", "9");
	            return;
	        }

	        /** 初始化一些变量 **/
			var is_start = false;
	        var rander_start = 0;
	        var rander_width = 0;
	        var timer = null;
	        var is_back = false;

	        /** 添加canvas控件 **/
	        $("#"+element).html("<canvas class='oyLabel'></canvas><canvas class='contentChart'></canvas>"+
            	"<div><canvas class='oxLabel'></canvas></div><canvas class='uterusYLabel'></canvas><canvas class='uterusChart'></canvas>");

	        /** 初始化canvas控件，并进行第一次绘制 **/
			Chart.chartInit(element);
            var canvasObj = $("#"+element+" .contentChart")[0];
            
            /** 记录canvas区域位置，用于后续的选取区域范围确定 **/
            var canvas_to_window = canvasObj.getBoundingClientRect();
            default_start = Math.floor(canvas_to_window.left);
            start_point = Math.floor(canvas_to_window.left);
            default_end = Math.floor(canvas_to_window.right);
            end_point = Math.floor(canvas_to_window.right);
            
            /** 添加超过胎心图最右侧的鼠标移动时间，可以让图自动往左边滚动，此处是拿定时器实现的 **/
			$("#"+element).mousemove(function(event){
				if(event.pageX > default_end && is_start){
					if(timer == null){
            			timer = setInterval(function(){
	            			canvasObj.width = Chart.getCanvasWidth();
	            			canvasObj.height = Chart.getCanvasHeight();
	            			context = canvasObj.getContext('2d');
            				context.clearRect(0,0,canvas_width,canvas_height);
	            			offsetX--;
	            			offset_can++;
		                   	rander_start = (start_point - canvas_to_window.left) * 2 - offset_can;
		                   	rander_width = (default_end - start_point) * 2 + Math.abs(offset_can);

		                   	Chart.moveEvent(context, element, offsetX);
		            		Chart.randerReportArea(context, rander_start, rander_width);
		            		
		            		var xLabelObj = $("#"+element+" .oxLabel")[0];
				            var xLabelContext = xLabelObj.getContext('2d');
				            xLabelContext.clearRect(0,0,canvas_width,label_height);
				            Chart.changeXLabel(xLabelContext, offsetX);
				            
				            var uterusYLabel = $("#"+element+" .uterusChart")[0];
				            var uyContext = uterusYLabel.getContext('2d');
				            uyContext.clearRect(0,0,canvas_width,uterus_height);
				            Chart.drawUterus(uyContext, element);
                		}, 5);
            		}
				}
			});

            canvasObj.onmousedown = function(event){
                var pos = Chart.windowToCanvas(canvasObj,event.clientX,event.clientY);
                canvasObj.onmousemove = function(event){
                    canvasObj.style.cursor = "move";
                    var pos1 = Chart.windowToCanvas(canvasObj,event.clientX,event.clientY);
                    var x = pos1.x - pos.x;
                    var y = pos1.y - pos.y;
                    pos = pos1;
                    offsetX+=x;
                    offsetY+=y;
                    Chart.draw(element, "drag");
                }
                canvasObj.onmouseup = function(){
                    canvasObj.onmousemove = null;
                    canvasObj.onmouseup = null;
                    canvasObj.style.cursor = "default";
                }
                canvasObj.ondblclick = function(event){
                	is_start = true;
                	is_back = false;
                	offset_can = 0;
	            	start_point = event.x || event.clientX;
	            	canvasObj.width = Chart.getCanvasWidth();
	            	canvasObj.height = Chart.getCanvasHeight();
	            	context = canvasObj.getContext('2d');

	            	context.clearRect(0,0,canvas_width,canvas_height);
	            	Chart.moveEvent(context, element, offsetX);
	            	Chart.randerReportArea(context, (start_point - canvas_to_window.left)*2, 5);

	            	canvasObj.onmousemove = function(event){
	            		var point_x = event.x || event.clientX;
	                    if(point_x > start_point && point_x < default_end){
	                    	context.clearRect(0,0,canvas_width,canvas_height);
                    		if(timer != null){
                    			clearInterval(timer);
                    			timer = null;
                    			is_back = true;
                    		}

		                   	rander_start = is_back ? rander_start : (start_point - canvas_to_window.left) * 2;
		                   	rander_width = is_back ? (point_x - start_point) * 2 + Math.abs(offset_can) : (point_x - start_point) * 2;

                    		Chart.moveEvent(context, element, offsetX);
		            		Chart.randerReportArea(context, rander_start, rander_width);
	            			end_point = point_x;
	                    }
	                }
	            }
            }
		},
		/** 此方法提供数据给flex画图，仅在不支持canvas时调用 **/
		initNSTData : function(){
			return Chart.curNstData;
		},
		/** 初始化canvas控件以及第一次渲染数据 **/
		chartInit : function(element){
            /** 初始化画图 **/
            var can = $("#"+element+" .contentChart")[0];
            can.width = Chart.getCanvasWidth();
            can.height = Chart.getCanvasHeight();
            context = can.getContext('2d');
            Chart.drawGrid(context, element);

            /** 初始化y周坐标 **/
            var yLabel = $("#"+element+" .oyLabel")[0];
            yLabel.width = Chart.getLabelWeight();
            yLabel.height = Chart.getCanvasHeight();
            var ylContext = yLabel.getContext('2d');
            Chart.drawLabelY(ylContext);

            /** 初始化X轴坐标 **/
            var xLabel = $("#"+element+" .oxLabel")[0];
            xLabel.width = Chart.getCanvasWidth();
            xLabel.height = Chart.getLabelHeight();
            var xlContext = xLabel.getContext('2d');
            Chart.drawLabelX(xlContext);
            
            /** 初始化宫缩图 **/
            var uterusChart = $("#"+element+" .uterusChart")[0];
            uterusChart.width = Chart.getCanvasWidth();
            uterusChart.height = Chart.getUterusHeight();
            var uterusContext = uterusChart.getContext('2d');
            Chart.drawUterus(uterusContext, element);
            
            /** 宫缩Y轴坐标 **/
            var uyLabel = $("#"+element+" .uterusYLabel")[0];
            uyLabel.width = Chart.getLabelWeight();
            uyLabel.height = Chart.getUterusHeight();
            var uyContext = uyLabel.getContext('2d');
            Chart.drawUterusLabelY(uyContext);
		},
		/** 清空重绘 **/
		draw : function(element){
            var obj = $("#"+element+" .contentChart")[0];
            var context = obj.getContext('2d');
            context.clearRect(0,0,canvas_width,canvas_height);
            Chart.moveEvent(context, element, offsetX);
            
            var xLabelObj = $("#"+element+" .oxLabel")[0];
            var xLabelContext = xLabelObj.getContext('2d');
            xLabelContext.clearRect(0,0,canvas_width,label_height);
            Chart.changeXLabel(xLabelContext, offsetX);
            
            var uterusYLabel = $("#"+element+" .uterusChart")[0];
            var uyContext = uterusYLabel.getContext('2d');
            uyContext.clearRect(0,0,canvas_width,uterus_height);
            Chart.drawUterus(uyContext, element);
		},
		/** 获取canvas相对于浏览器窗口的位置信息 **/
		windowToCanvas : function(canvas, x, y){
			var bbox = canvas.getBoundingClientRect();
            return {
                x:x - bbox.left - (bbox.width - canvas.width) / 2,
                y:y - bbox.top - (bbox.height - canvas.height) / 2
            };
		},
		/** 胎心图区域绘图总方法 **/
		drawGrid : function(context, element){
			/** X轴 **/
			Chart.drawGridLineX(context);
			/** Y轴 **/
			Chart.drawGridLineY(context);
			/** 正常范围背景渲染 **/
			Chart.randerNormalArea(context);
			/** 胎心曲线描点 **/
			Chart.randerValue(context, element, offsetX);
		},
		/** 画出X轴线 **/
		drawGridLineX : function(context){
			/** X轴初始化 **/
			for(var i = 0;i <= required_vertical;i++){
				context.beginPath();
				var oy = vertical_size * i - 0.5;
				if(i == 0){
					oy = 0.5;
				}

				/** 刻度加粗 **/
				if(i % 3 == 0){
					context.lineWidth = 2;
				}else{
					context.lineWidth = 1;
				}
				context.moveTo(0.5, oy);
				context.lineTo(canvas_width+0.5, oy);
	            context.strokeStyle = colorSelect['line'];
	            context.stroke();
	            context.closePath();
			}
		},
		/** 画出Y轴线 **/
		drawGridLineY : function(context){
			/** Y轴初始化 **/
			if(offsetX >= 0){
				for(var j = 0;j <= required_horizontal;j++){
					context.beginPath();
					var ox = horizontal_size * j - 0.5;
					if(j == 0){
						ox = 0.5;
					}
					context.lineWidth = 1;
					context.moveTo(ox, 0.5);
					context.lineTo(ox, canvas_height + 0.5);
		            context.strokeStyle = colorSelect['line'];
		            context.stroke();
		            context.closePath();
				}
			}else{
				for(var j = 0;j <= required_horizontal;j++){
					var absOffsetX = Math.abs(offsetX);
					var beginPoint = horizontal_size - absOffsetX % horizontal_size;
					var blodLine = 6 - Math.ceil(absOffsetX / 40);

					context.beginPath();
					var ox = beginPoint + horizontal_size * j - 0.5;
					context.lineWidth = 1;
					context.moveTo(ox, 0.5);
					context.lineTo(ox, canvas_height + 0.5);
		            context.strokeStyle = colorSelect['line'];
		            context.stroke();
		            context.closePath();
				}
			}

			/** 固定首位两条线 **/
			context.beginPath();
			context.moveTo(0.5, 0.5);
			context.lineTo(0.5, canvas_height + 0.5);
            context.strokeStyle = colorSelect['line'];
            context.stroke();
            context.closePath();

            context.beginPath();
			context.moveTo(2399.5, 0.5);
			context.lineTo(2399.5, canvas_height + 0.5);
            context.strokeStyle = colorSelect['line'];
            context.stroke();
            context.closePath();
		},
		/** 此处渲染正常区域透明绿色 **/
		randerNormalArea : function(context){
			context.beginPath();
			context.fillStyle =colorSelect['safe'];
			context.fillRect(0,vertical_size * 8,canvas_width,vertical_size * 5);
			context.closePath();
		},
		/** X轴横坐标设置值 **/
		drawLabelX : function(context){
			var xValue = 0;
			for(var j = 0;j <= required_horizontal;j++){
				if(j % 3 == 0){
					context.font = "23px 黑体";
					context.fillStyle = "black";
					xValue = j / 6 * 2;
					if(j == 0){
						context.fillText(xValue, horizontal_size * j, 20);
					}else if(j == required_horizontal){
						context.fillText(xValue, horizontal_size * j - 30, 20);
					}else{
						context.fillText(xValue, horizontal_size * j - 10, 20);
					}
				}
			}
		},
		/** Y轴纵坐标设置值 **/
		drawLabelY : function(context){
			var yValue = 240;
			for(var i = 0;i <= required_vertical;i++){
				if(i % 3 == 0){
					context.font = "23px 黑体";
					context.fillStyle = "black";
					if(i == 0){
						context.fillText(yValue, 10, vertical_size * i + 20);
					}else if(i == required_vertical){
						context.fillText(yValue, 10, vertical_size * i);
					}else{
						context.fillText(yValue, 10, vertical_size * i + 10);
					}
					yValue = yValue - 30;
				}
			}
		},
		/** 胎心曲线描点 **/
		randerValue : function(context, element, ox){
			var fhrData = Chart.getDataByElement(element).fhr_data;
			var uaData = Chart.getDataByElement(element).ua_data;
			if(fhrData && fhrData.length > 0){
				if (ox >= 0) {
					ox = 0;
					offsetX = 0;
				}else{
					ox = Math.abs(ox);
				}
				context.beginPath();
				var fhrLength = fhrData.length;
				for(var i = ox;i < fhrLength; i++){
					var x_point = this.isInteger(i - ox) ? i - ox : i - ox + 0.5;
					var y_height = canvas_height - (fhrData[i] - 30) * 2;
					var y_point = this.isInteger(y_height) ? y_height : y_height + 0.5;
					if(Math.abs(fhrData[i] - fhrData[i - 1]) > 30){
						context.moveTo(x_point, y_point);
					}else{
						context.lineTo(x_point, y_point);
					}
				}
				context.lineWidth = 1;
	            context.strokeStyle = colorSelect['black'];
	            context.stroke();
	            context.closePath();
			}
			
			ox = Math.abs(ox);
			if(uaData && uaData != null && uaData.length > 0){
				var uaLength = uaData.length;
				for(var i = 0;i < uaLength; i++){
					context.beginPath();
					context.fillStyle = "rgb(0,0,0)";
				    context.fillRect(uaData[i] * 2 - ox, 390, 4, 16);
				    context.fill();
				    context.stroke();
				}
			}
		},
		/** 拖动canvas时重绘胎心图方法 **/
		moveEvent : function(context, element, ox){
			/** X轴 **/
			Chart.drawGridLineX(context);
			/** Y轴 **/
			Chart.drawGridLineY(context);
			/** 正常范围背景渲染 **/
			Chart.randerNormalArea(context);
			/** 胎心曲线描点 **/
			Chart.randerValue(context, element, ox);
		},
		/** 改变X轴 **/
		changeXLabel : function(context, ox){
			if(ox >= 0){
				context.clearRect(0,0,Chart.getCanvasWidth(),Chart.getLabelHeight());
				Chart.drawLabelX(context);
			}else{
				for(var j = 0;j <= required_horizontal;j++){
					var absOffsetX = Math.abs(offsetX);
					var beginPoint = horizontal_size - absOffsetX % horizontal_size;
					var blodLine = 6 - Math.ceil(absOffsetX / 40);
					var index = (Math.floor(absOffsetX / 240) + 1) * 2;

					context.font = "23px 黑体";
					context.fillStyle = "black";

					/** 刻度加粗 **/
					if(j == blodLine){
						context.fillText(index, beginPoint + horizontal_size * j - 10, 20);
					}else{
						if((j - blodLine) % 3 == 0){
							context.fillText((j - blodLine) / 6 * 2 + 2, beginPoint + horizontal_size * j - 10, 20);
						}
					}
				}
			}
		},
		clear : function(element){
			var obj = $("#"+element+" .contentChart")[0];
            var context = obj.getContext('2d');
            context.clearRect(0,0,canvas_width,canvas_height);
            Chart.moveEvent(context,element,0);
            
            var xLabelObj = $("#"+element+" .oxLabel")[0];
            var xLabelContext = xLabelObj.getContext('2d');
            xLabelContext.clearRect(0,0,canvas_width,label_height);
            Chart.changeXLabel(xLabelContext, 0);
            
            var uterusChart = $("#"+element+" .uterusChart")[0];
            var uterusContext = uterusChart.getContext('2d');
            uterusContext.clearRect(0,0,canvas_width,uterus_height);
            this.setOffsetX(element, 0);
		},
		/** 画出宫缩图Y轴值 **/
		drawUterusLabelY : function(context){
			var yValue = 100;
			for(var i = 0;i < uterus_vertical;i++){
				if(i % 2 == 0){
					context.font = "23px 黑体";
					context.fillStyle = "black";
					if(i == 0){
						context.fillText(yValue, 10, vertical_size * i + 16);
					}else if(i == uterus_vertical - 1){
						context.fillText(yValue, 10, vertical_size * i);
					}else{
						context.fillText(yValue, 10, vertical_size * i + 5);
					}
					yValue = yValue - 20;
				}
			}
		},
		/** 宫缩图画图总方法 **/
		drawUterus : function(context, element){
			Chart.drawUterusXLine(context);
			Chart.drawUterusYLine(context);
			Chart.randerUterusValue(context, element, offsetX);
		},
		/** 宫缩图X轴表格画图方法 **/
		drawUterusXLine : function(context){
			for(var i = 0; i < uterus_vertical; i++){
				context.beginPath();
				var oy = vertical_size * i - 0.5;
				if(i == 0){
					oy = 0.5;
				}

				/** 刻度加粗 **/
				if(i % 2 == 0){
					context.lineWidth = 2;
				}else{
					context.lineWidth = 1;
				}
				context.moveTo(0.5, oy);
				context.lineTo(canvas_width+0.5, oy);
	            context.strokeStyle = colorSelect['line'];
	            context.stroke();
	            context.closePath();
			}
		},
		/** 宫缩图Y轴表格画图方法 **/
		drawUterusYLine : function(context){
			/** Y轴初始化 **/
			if(offsetX >= 0){
				for(var j = 0;j <= required_horizontal;j++){
					context.beginPath();
					var ox = horizontal_size * j - 0.5;
					if(j == 0){
						ox = 0.5;
					}
					
					context.lineWidth = 1;
					context.moveTo(ox, 0.5);
					context.lineTo(ox, canvas_height + 0.5);
		            context.strokeStyle = colorSelect['line'];
		            context.stroke();
		            context.closePath();
				}
			}else{
				for(var j = 0;j <= required_horizontal;j++){
					var absOffsetX = Math.abs(offsetX);
					var beginPoint = horizontal_size - absOffsetX % horizontal_size;
					var blodLine = 6 - Math.ceil(absOffsetX / 40);

					context.beginPath();
					var ox = beginPoint + horizontal_size * j - 0.5;
					context.lineWidth = 1;
					context.moveTo(ox, 0.5);
					context.lineTo(ox, canvas_height + 0.5);
		            context.strokeStyle = colorSelect['line'];
		            context.stroke();
		            context.closePath();
				}
			}

			/** 固定首位两条线 **/
			context.beginPath();
			context.moveTo(0.5, 0.5);
			context.lineTo(0.5, canvas_height + 0.5);
            context.strokeStyle = colorSelect['line'];
            context.stroke();
            context.closePath();

            context.beginPath();
			context.moveTo(2399.5, 0.5);
			context.lineTo(2399.5, canvas_height + 0.5);
            context.strokeStyle = colorSelect['line'];
            context.stroke();
            context.closePath();
		},
		/** 宫缩曲线图描点 **/
		randerUterusValue : function(context, element, ox){
			var fmpData = Chart.getDataByElement(element).fmp_data;
			if(fmpData && fmpData.length > 0){
				ox = Math.abs(ox);
				context.beginPath();
				var fmpLength = fmpData.length;
				for(var i = ox;i < fmpLength; i++){
					var fmpX = this.isInteger(i - ox) ? i - ox + 0.5 : i - ox;
					var fmpY = this.isInteger(uterus_height - fmpData[i] * 2) ? uterus_height - fmpData[i] * 2 + 0.5 : uterus_height - fmpData[i] * 2;
					context.lineTo(fmpX,  fmpY);
				}
				context.lineWidth = 1;
	            context.strokeStyle = colorSelect['black'];
	            context.stroke();
	            context.closePath();
			}
		},
		/** 生成报告胎心选取区域范围渲染 **/
		randerReportArea : function(context, start, width){
			context.fillStyle =colorSelect['grey'];
			context.fillRect(start,0,width,canvas_height);
		},
		/** 设置选取范围值，用于返回到前端，并提供给后台生成报告 **/
		setResultData : function(result){
			var resultArray = result.split("-");
			result_start = resultArray[0];
			result_end = resultArray[1];
		},
		/** 对外获取胎心选取区域的方法 **/
		getResultData : function(element){
			var fhrData = Chart.getDataByElement(element).fhr_data;
			if(isCanvas){
				var start_index = (start_point - default_start) * 2;
	            var end_index = (end_point - default_start) * 2;
	            result_start = start_index + Math.abs(offsetX) - Math.abs(offset_can);
	            result_end = end_index + Math.abs(offsetX);
			}
			result_end = result_end == 2400 ? fhrData.length : result_end;
			return result_start+"-"+result_end;
		}
	}
	
}();